6 # I use this in EVERY shell script ;)
11 while ! [ -f ./all ]; do
12 if [ x"`pwd`" = x"/" ]; then
13 echo "Cannot find myself."
14 echo "Please run this script with the working directory inside a Xonotic checkout."
22 # If we are on WINDOWS:
27 # Windows hates users. So this script has to copy itself elsewhere first...
29 cp "$SELF" ../all.xonotic.sh
30 export WE_HATE_OUR_USERS=1
31 exec ../all.xonotic.sh "$@"
44 if [ -x /usr/bin/md5sum ]; then
46 elif [ -x /bin/md5sum ]; then
48 elif [ -x /usr/bin/cksum ]; then
55 self=`checksum "$SELF"`
58 self_new=`checksum "$SELF"`
59 if [ x"$self" != x"$self_new" ]; then
60 msg "./all has changed."
61 if [ -z "$XONOTIC_FORBID_RERUN_ALL" ]; then
62 msg "Rerunning the requested operation to make sure."
63 export XONOTIC_FORBID_RERUN_ALL=1
66 msg "Please try $SELF update, and then retry your requested operation."
83 echo "the root directory"
93 if git ls-files -u | grep ' 1 '; then
95 echo "MERGE CONFLICT."
96 echo "change into the \"$1\" project directory, and then:"
97 echo "- edit the files mentioned above with your favorite editor,"
98 echo " and fix the conflicts (marked with <<<<<<< blocks)"
99 echo "- for binary files, you can select the files using"
100 echo " git checkout --ours or git checkout --theirs"
101 echo "- when done with a file, 'git add' the file"
102 echo "- when done, 'git commit'"
111 while [ x"$yesno" != x"y" -a x"$yesno" != x"n" ]; do
122 check_mergeconflict "$1"
127 data/xonotic-data.pk3dir | | master |
128 data/xonotic-maps.pk3dir | | master |
129 data/xonotic-music.pk3dir | | master |
130 data/xonotic-nexcompat.pk3dir | | master |
131 mediasource | | master |
132 darkplaces | | div0-stable | svn
133 fteqcc | git://github.com/Blub/qclib.git | master |
134 div0-gittools | git://git.icculus.org/divverent/div0-gittools.git | master |
135 netradiant | | master |
137 # todo: in darkplaces, change repobranch to div0-stable
139 repos=`echo "$repos_urls" | grep . | cut -d '|' -f 1 | tr -d ' '`
141 base=`git config remote.origin.url`
144 base=${base%xonotic.git}
147 echo "The main repo is not xonotic.git, what have you done?"
154 t=`echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 2 | tr -d ' '`
165 if [ x"$1" = x"." ]; then
166 echo "$base""xonotic.git"
168 echo "$base${1##*/}.git"
175 t=`echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 3 | tr -d ' '`
185 echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 4 | tr -d ' '
189 repos=`for d in $repos; do
191 if [ x"$p" = x"$d" ] || [ -d "$d" ] || ! { [ -f "$d.no" ] || [ -f "$p" ]; }; then
196 if [ "$#" = 0 ]; then
205 if [ x"$1" = x"-N" ]; then
210 branch=`repobranch "$d"`
211 if [ -d "$d0/$d" ]; then
213 enter "$d0/$d" verbose
214 verbose git config remote.origin.url "$url"
215 verbose git config remote.origin.fetch "+refs/heads/*:refs/remotes/origin/*"
217 r=`git symbolic-ref HEAD`
219 if git config branch.$r.remote >/dev/null 2>&1; then
220 if ! verbose git pull; then
221 check_mergeconflict "$d"
222 echo "Pulling failed. Press ENTER to continue, or Ctrl-C to abort."
228 checkself "$cmd" "$@"
230 verbose git remote prune origin
234 verbose git clone "$url" "$d0/$d"
235 enter "$d0/$d" verbose
236 if [ "$branch" != "master" ]; then
237 verbose git checkout --track -b "$branch" origin/"$branch"
244 misc/tools/xonotic-map-compiler-autobuild download
249 if [ -z "$branch" ]; then
252 branch=${remote#origin/}
263 enter "$d0/$d" verbose
265 if [ -n "$b" ] && git rev-parse "refs/heads/$b" >/dev/null 2>&1; then
267 verbose git checkout "$b"
268 elif [ -n "$b" ] && git rev-parse "refs/remotes/$remote/$b" >/dev/null 2>&1; then
270 verbose git checkout --track -b "$b" "$remote/$b"
273 if git rev-parse "refs/heads/$b" >/dev/null 2>&1; then
275 verbose git checkout "$b"
276 elif git rev-parse "refs/remotes/$remote/$b" >/dev/null 2>&1; then
278 verbose git checkout --track -b "$b" "$remote/$b"
280 echo "WTF? Not even branch $b doesn't exist in $d"
285 checkself "$cmd" "$@"
289 echo "The requested branch was not found in any repository."
297 if [ -z "$branch" ]; then
301 if [ -z "$branch" ]; then
304 r=`git symbolic-ref HEAD`
311 dv=`visible_repo_name "$d"`
312 enter "$d0/$d" verbose
313 if git rev-parse "refs/heads/$branch" >/dev/null 2>&1; then
314 echo "Already having this branch in $dv."
316 if yesno "Branch in $dv?"; then
317 if [ -n "$srcbranch" ]; then
320 b=origin/"`repobranch "$d"`"
321 verbose git fetch origin || true
323 # TODO do this without pushing
324 verbose git checkout -b "$branch" "$b"
325 verbose git config "branch.$branch.remote" "$remote"
326 verbose git config "branch.$branch.merge" "refs/heads/$branch"
336 cd "$d0/$d" # am in a pipe, shouldn't use enter
337 git branch -a -v -v | cut -c 3- | sed "s,^,$d ,"
342 while read -r d BRANCH REV UPSTREAM TEXT; do
343 if [ x"$BRANCH" = x"`repobranch "$d"`" ]; then
348 UPSTREAM=${UPSTREAM#\[}
349 UPSTREAM=${UPSTREAM%\]}
350 UPSTREAM=${UPSTREAM%:*}
353 TEXT="$UPSTREAM $TEXT"
357 if [ x"$REV" = x"->" ]; then
360 BRANCH=${BRANCH#remotes/}
361 ID=`echo "$BRANCH" | tr -c "A-Za-z0-9." "_"`
362 branches_list="$branches_list $BRANCH" # TEH SORT MAKEZ IT UNIEQ
363 eval "r=\$branches_repos_$ID"
372 eval "branches_repos_$ID=\$r"
374 echo -n "$branches_list" | xargs -n 1 echo | sort -u | while IFS= read -r BRANCH; do
375 ID=`echo "$BRANCH" | tr -c "A-Za-z0-9." "_"`
376 eval "r=\$branches_repos_$ID"
377 printf "%-60s %s\n" "$BRANCH" "$r"
384 dv=`visible_repo_name "$d"`
385 enter "$d0/$d" verbose
386 r=`git symbolic-ref HEAD`
388 if git log HEAD..origin/"`repobranch "$d"`" | grep .; then
389 # we have uncommitted changes
390 if yesno "Could merge from \"`repobranch "$d"`\" into \"$r\" in $dv. Do it?"; then
391 if ! verbose git merge origin/"`repobranch "$d"`"; then
392 check_mergeconflict "$d"
393 exit 1 # this should ALWAYS be fatal
403 dv=`visible_repo_name "$d"`
404 enter "$d0/$d" verbose
405 r=`git symbolic-ref HEAD`
407 if git diff HEAD | grep .; then
408 # we have uncommitted changes
409 if yesno "Uncommitted changes in \"$r\" in $dv. Commit?"; then
410 verbose git commit -a
413 rem=`git config "branch.$r.remote" || echo origin`
414 bra=`git config "branch.$r.merge" || echo "$r"`
416 if ! [ git rev-parse "$upstream" ]; then
417 upstream="`repobranch "$d"`"
419 if git log "$upstream".."$r" | grep .; then
420 if yesno "Push \"$r\" in $dv?"; then
421 verbose git push "$rem" HEAD
424 if [ x"$submit" = x"-s" ]; then
427 verbose git push "$rem" HEAD:"${bra%%/*}/finished/${bra#*/}"
435 if [ -n "$WE_HATE_OUR_USERS" ]; then
436 TARGETS="sv-debug cl-debug"
437 if [ -z "$CC" ]; then
440 elif [ x"`uname`" = x"Darwin" ] && ( [ -d /Library/Frameworks/SDL.framework ] || [ -d $(HOME)/Library/Frameworks/SDL.framework ] ); then
441 # AGL is broken in Snow Leopard, so let's default to SDL if it is available.
442 TARGETS="sv-debug sdl-debug"
444 TARGETS="sv-debug cl-debug sdl-debug"
469 if [ -z "$MAKEFLAGS" ]; then
470 if [ -f /proc/cpuinfo ]; then
471 ncpus=$((`grep -c '^processor :' /proc/cpuinfo`+0))
472 if [ $ncpus -gt 1 ]; then
478 MAKEFLAGS="$MAKEFLAGS DP_LINK_TO_LIBJPEG=1"
481 if [ -n "$WE_HATE_OUR_USERS" ]; then
482 MAKEFLAGS="$MAKEFLAGS DP_MAKE_TARGET=mingw"
485 enter "$d0/fteqcc" verbose
487 verbose make $MAKEFLAGS clean
489 verbose make $MAKEFLAGS
490 enter "$d0/data/xonotic-data.pk3dir" verbose
492 verbose make $MAKEFLAGS clean
494 verbose make FTEQCC="$d0/fteqcc/fteqcc.bin" "$@" $MAKEFLAGS clean
495 verbose make FTEQCC="$d0/fteqcc/fteqcc.bin" "$@" $MAKEFLAGS
496 enter "$d0/darkplaces" verbose
498 verbose make $MAKEFLAGS clean
500 for T in $TARGETS; do
501 verbose make $MAKEFLAGS "$@" "$T"
503 verbose "$SELF" update-maps
509 if [ -n "$WE_HATE_OUR_USERS" ]; then
511 export PATH="$d0/misc/buildfiles/w32:$PATH"
512 elif [ x"`uname`" = x"Darwin" ]; then
513 export DYLD_LIBRARY_PATH="$d0/misc/buildfiles/osx/Xonotic-SDL.app/Contents/MacOS"
519 sdl|glx|agl|dedicated)
528 if ! [ -x "darkplaces/darkplaces$client" ]; then
529 if [ -x "darkplaces/darkplaces$client.exe" ]; then
532 echo "Client darkplaces/darkplaces$client not found, aborting"
536 set -- "darkplaces/darkplaces$client" -nexuiz -customgamename Xonotic -customgamedirname1 data -customgamedirname2 "" -customgamescreenshotname xonotic -customgameuserdirname xonotic "$@"
538 # if pulseaudio is running: USE IT
539 if [ -z "$SDL_AUDIODRIVER" ] && ! [ -n "$WE_HATE_OUR_USERS" ] && ! [ x"`uname`" = x"Darwin" ]; then
540 if ps -C pulseaudio >/dev/null; then
541 if ldd /usr/lib/libSDL.so 2>/dev/null | grep pulse >/dev/null; then
542 export SDL_AUDIODRIVER=pulse
547 if [ -n "$USE_GDB" ]; then
548 set -- gdb --args "$@"
554 if [ x"$1" = x"-k" ]; then
559 if verbose cd "$d0/$d"; then
571 patchdir=`mktemp -d -t save-patches.XXXXXX`
573 enter "$d0/$d" verbose
574 git branch -v -v | cut -c 3- | {
576 while read -r BRANCH REV UPSTREAM TEXT; do
579 UPSTREAM=${UPSTREAM#\[}
580 UPSTREAM=${UPSTREAM%\]}
581 UPSTREAM=${UPSTREAM%:*}
585 UPSTREAM=origin/"`repobranch "$d"`"
589 if [ x"$REV" = x"->" ]; then
592 if git format-patch -o "$patchdir/$i" "$UPSTREAM".."$BRANCH"; then
593 echo "$d" > "$patchdir/$i/info.txt"
594 echo "$BRANCH" >> "$patchdir/$i/info.txt"
595 echo "$UPSTREAM" >> "$patchdir/$i/info.txt"
596 echo "$TRACK" >> "$patchdir/$i/info.txt"
599 rm -rf "$patchdir/$i"
604 ( cd "$patchdir" && tar cvzf - . ) > "$outfile"
609 patchdir=`mktemp -d -t restore-patches.XXXXXX`
610 ( cd "$patchdir" && tar xvzf - ) < "$infile"
612 for P in "$patchdir"/*/info.txt; do
619 verbose git checkout HEAD^0
620 verbose git branch -D "$BRANCH"
621 if [ x"$TRACK" = x"true" ]; then
622 verbose git checkout --track -b "$BRANCH" "$UPSTREAM"
624 verbose git branch -b "$BRANCH" "$UPSTREAM"
631 if [ "$#" = 1 ]; then
632 set -- "${1%%/*}" "${1#*/}"
635 enter "$d0/$d" verbose
636 git rev-parse "$1/$2" || continue
639 git log HEAD.."$1/$2"
640 git diff HEAD..."$1/$2"
642 if yesno "Merge \"$1/$2\" into `git symbolic-ref HEAD` of $d?"; then
644 if "$SELF" compile && yesno "Still merge \"$1/$2\" into `git symbolic-ref HEAD` of $d? Maybe you want to test first."; then
648 git reset --hard HEAD@{1}
658 report=$report"$*$LF"
663 report=$report" $*$LF"
668 o=`"$@" | sed 's/^/ /' || true`
672 enter "$d0/$d" verbose
673 base="`repobranch "$d"`"
675 for ref in `git for-each-ref --format='%(refname)' refs/remotes/origin/`; do
676 case "${ref#refs/remotes/origin/}" in
684 reportecho " Branch $ref:"
685 note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
686 logdata=`git log --color "$base".."$ref"`
687 diffdata=`git diff --color --find-copies-harder --ignore-space-change "$base"..."$ref"`
688 if [ -z "$logdata" ]; then
689 reportecho4 "--> not merging, no changes vs master"
690 elif [ -z "$diffdata" ]; then
691 reportecho4 "--> not merging, no changes vs master, branch contains redundant history"
692 if yesno "Branch \"$ref\" probably should get deleted. Do it?" '{ echo "$logdata"; } | less -r'; then
693 git push origin :"${ref#refs/remotes/origin/}"
694 reportecho4 "--> branch deleted"
696 elif [ -n "$note" ]; then
697 reportdo4 echo "$note"
698 reportecho4 "--> not merging, already had this one rejected before"
699 elif yesno "Branch \"$ref\" may want to get merged. Do it?" '{ echo "$logdata"; echo "$diffdata"; } | less -r'; then
701 org=`git rev-parse HEAD`
702 if ! git merge "$ref" 2>&1 | tee "$t"; then
703 git reset --hard "$org"
704 GIT_NOTES_REF=refs/notes/admin-merge git notes edit -m "Merge failed:$LF`cat "$t"`" "$ref"
706 reportecho4 "--> merge failed"
707 elif ! "$SELF" compile 2>&1 | tee "$t"; then
708 git reset --hard "$org"
709 GIT_NOTES_REF=refs/notes/admin-merge git notes edit -m "Compile failed:$LF`cat "$t"`" "$ref"
711 reportecho4 "--> compile failed"
712 elif ! yesno "Still merge \"$ref\" into `git symbolic-ref HEAD` of $d? Maybe you want to test first."; then
713 git reset --hard "$org"
714 git notes edit "$ref"
715 note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
716 reportdo4 echo "$note"
717 reportecho4 "--> test failed"
719 case ",`repoflags "$d"`," in
721 # we do quite a mess here... luckily we know $org
722 git pull # svn needs to be current
723 git rebase -i --onto master "$org"
724 git svn dcommit --add-author-from
725 git reset --hard "$org"
731 reportecho4 "--> MERGED"
732 if yesno "Delete original branch \"$ref\"?"; then
733 git push origin :"${ref#refs/remotes/origin/}"
734 reportecho4 "--> branch deleted"
738 GIT_NOTES_REF=refs/notes/admin-merge git notes edit "$ref"
739 note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
740 if [ -n "$note" ]; then
741 reportdo4 echo "$note"
742 reportecho4 "--> rejected"
744 reportecho4 "--> postponed"
752 echo "$report" | ssh nexuiz@rm.endoftheinternet.org cat '>>' public_html/xonotic-merge-notes.txt
755 # release building goes here
757 mkdir -p Xonotic/"$1"
760 #"$SELF" each git clean -fxd
762 "$SELF" release-copy Docs/
763 "$SELF" release-copy misc/
764 "$SELF" release-copy server/
765 "$SELF" release-copy xonotic-linux-glx.sh
766 "$SELF" release-copy xonotic-linux-sdl.sh
767 "$SELF" release-mkdir data
768 "$SELF" release-mkdir fteqcc
771 rsync --exclude=.git -vaSHPAX "$1" Xonotic/"$1"
780 rsync --delete -zvaSHPAX "$srcdir"/ "$host:$buildpath/"
781 ssh "$host" ". ~/.profile && cd $buildpath && make clean $maketargets $makeflags"
782 for f in $targetfiles; do
783 rsync -zvaSHPAX "$host:$buildpath/${f%:*}" "${f##*:}"
789 fteqcc_maketargets=$3
791 darkplaces_maketargets=$5
793 "$SELF" release-compile-run "xonotic-build-$suffix" /tmp/fteqcc.build."$suffix" "$fteqcc_maketargets" "$makeflags" "fteqcc" "$fteqcc_files"
794 "$SELF" release-compile-run "xonotic-build-$suffix" /tmp/Darkplaces.build."$suffix" "$darkplaces_maketargets" "$makeflags" "fteqcc" "$darkplaces_files"
796 release-engine-win32)
797 rsync --exclude=.git -vaSHPAX Xonotic/misc/buildfiles/w32/* Xonotic/
798 "$SELF" release-compile win32 \
799 '"DP_MAKE_TARGET=mingw CC="$HOME/mingw32/bin/i386-mingw32-gcc -g -DSUPPORTDIRECTX -DUSE_WSPIAPI_H -I$HOME/dxheaders" WINDRES="$HOME/mingw32/bin/i386-mingw32-windres" SDL_CONFIG="$HOME/sdl-win32/SDL-1.2.13/bin/sdl-config"' \
800 win 'fteqcc.exe:Xonotic/fteqcc/fteqcc.exe' \
801 debug 'darkplaces.exe:xonotic.exe darkplaces-sdl.exe:xonotic-sdl.exe darkplaces-dedicated.exe:xonotic-dedicated.exe'
804 rsync --exclude=.git -vaSHPAX Xonotic/misc/buildfiles/osx/* Xonotic/
805 "$SELF" release-compile osx \
806 'CC="gcc -g -arch i386 -arch ppc -arch x86_64 -isysroot /Developer/SDKs/MacOSX10.5.sdk -mmacosx-version-min=10.5"' \
807 all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.osx' \
808 sdl-debug 'darkplaces-sdl:Xonotic/Xonotic-SDL.app/Contents/MacOS/xonotic-osx-sdl-bin'
810 release-engine-linux32)
811 "$SELF" release-compile linux32 \
812 'CC="gcc -g -Wl,--hash-style=sysv" DP_MODPLUG_STATIC_LIBDIR=$HOME/modplug-i386/lib DP_LINK_TO_LIBJPEG=1 LDFLAGS_LIBJPEG="$HOME/jpeg7/lib/libjpeg.a" CFLAGS_LIBJPEG="-I$HOME/jpeg7/include"' \
813 all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.linux32' \
814 debug 'darkplaces-glx:Xonotic/xonotic-linux-linux32-glx darkplaces-sdl:Xonotic/xonotic-linux-linux32-sdl darkplaces-dedicated:Xonotic/xonotic-linux-linux32-dedicated'
816 release-engine-linux64)
817 "$SELF" release-compile linux64 \
818 'CC="gcc -g -Wl,--hash-style=sysv" DP_MODPLUG_STATIC_LIBDIR=$HOME/modplug-x86_64/lib DP_LINK_TO_LIBJPEG=1 LDFLAGS_LIBJPEG="$HOME/jpeg7/lib/libjpeg.a" CFLAGS_LIBJPEG="-I$HOME/jpeg7/include"' \
819 all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.linux64' \
820 debug 'darkplaces-glx:Xonotic/xonotic-linux-linux64-glx darkplaces-sdl:Xonotic/xonotic-linux-linux64-sdl darkplaces-dedicated:Xonotic/xonotic-linux-linux64-dedicated'
823 "$SELF" release-engine-win32
824 "$SELF" release-engine-osx
825 "$SELF" release-engine-linux32
826 "$SELF" release-engine-linux64
830 for X in data/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
832 cd Xonotic/data/xonotic-maps.pk3dir
839 # version numnber and stuff like that
841 release-buildpk3-transform-raw)
843 release-buildpk3-transform-normal)
844 # texture: convert to jpeg
846 release-buildpk3-transform-low)
847 # texture: convert to jpeg and downscale
848 # music: reduce bitrate
862 rsync --exclude=.git -vaSHPAX "$src"/ "Xonotic/temp"
863 "$SELF" release-buildpk3-transform-$transform "Xonotic/temp"
864 7za a -tzip -mx=9 "$dst" .
870 while [ "$#" -gt 1 ]; do
871 "$SELF" release-buildpk3 "$src" "Xonotic/${src%.pk3dir}$2.pk3" "$1"
876 #"$SELF" release-buildpk3s data/font-dejavu.pk3dir raw ''
877 #"$SELF" release-buildpk3s data/xonotic-data.pk3dir normal '' raw '-raw' low '-low'
878 #"$SELF" release-buildpk3s data/xonotic-maps.pk3dir normal '' raw '-raw' low '-low'
879 #"$SELF" release-buildpk3s data/xonotic-music.pk3dir normal '' raw '-raw' low '-low'
880 #"$SELF" release-buildpk3s data/xonotic-nexcompat.pk3dir low ''
881 "$SELF" release-buildpk3s data/font-dejavu.pk3dir raw ''
882 "$SELF" release-buildpk3s data/xonotic-data.pk3dir raw ''
883 "$SELF" release-buildpk3s data/xonotic-maps.pk3dir raw ''
884 "$SELF" release-buildpk3s data/xonotic-music.pk3dir raw ''
885 "$SELF" release-buildpk3s data/xonotic-nexcompat.pk3dir raw ''
888 "$SELF" release-prepare
889 "$SELF" release-engine
890 "$SELF" release-gamedata
892 "$SELF" release-finish
899 echo " $SELF push [-s]"
900 echo " $SELF branches"
901 echo " $SELF branch [<remote>] <branchname>"
902 echo " $SELF branch <remote> <branchname> <srcbranchname>"
903 echo " $SELF checkout [<remote>] <branchname>"
904 echo " $SELF compile [-c] [<client>] <options>"
905 echo " $SELF run [<client>] <options>"
906 echo " $SELF each <command>"